import math,random
def array(N1,N2=0):#■配列の宣言
    if N2==0: return [0 for i in range(N1)]
    return [[0 for i in range(N2)]for j in range(N1)]
def printArray(A,Title="Array",frm="%6.2f"):#■配列の表示
    for i in range(len(A)):
        S=""
        for j in range(len(A[i])):S +=frm% A[i][j]
        print(S)
def printTriArray(A,Title="Array",frm="%5.2f"):
    print("\n"+Title)
    for i in range(len(A)):
        S=""
        for j in range(i):S +=frm% A[i][j]
        print(S)
NUMFREQ = 9              #出現素子値組数
NUMNODE =10              #ノード数(しきい値用を含む)
NUMINPUT= 8              #入力数
X=array(NUMNODE)         #各ノードの値
SumQin=array(NUMINPUT+1) #入力パターン生成用累積分布
numID=array(2,NUMFREQ)   #出現回数
P=array(2,NUMFREQ)       #出現頻度
sumQ=array(3,NUMINPUT)   #
Eps=0.2                  #ε
ERR=0                    #誤差
NumOfLearn=0             #実際回数
W=array(NUMNODE,NUMNODE) #重み行列
Wp=array(NUMNODE,NUMNODE) #重み行列
Wn=array(NUMNODE,NUMNODE) #重み行列

sigmoidTable=array(200)  #シグモイド関数表
InputPattern=0
OutputPattern=0
NumUpdate=400#更新回数
MaxLearn=5000#学習回数
debugMode=False
dspLearn=False
#■入力パターン生成値のための頻度
#      0    1    2    3     4   5     6   7     
Qin=[ 0.20,0.20,0.00,0.00,0.20,0.00,0.20,0.20]
Q  =[[1.00,0.00,0.00,0.00,0.00,0.00,1.00,0.00],
     [0.00,1.00,0.00,0.00,1.00,0.00,0.00,1.00]]
#         0 1 2 3 4 5 6 7 8 9
connect=[[0,0,0,0,1,1,1,1,1,1],
         [0,0,0,0,1,1,1,1,1,0],
         [0,0,0,0,1,1,1,1,1,0],
         [0,0,0,0,1,1,1,1,1,0],
         [1,1,1,1,0,0,0,0,0,1],
         [1,1,1,1,0,0,0,0,0,1],
         [1,1,1,1,0,0,0,0,0,1],
         [1,1,1,1,0,0,0,0,0,1],
         [1,1,1,1,0,0,0,0,0,1],
         [1,0,0,0,1,1,1,1,1,0]]
def printConnect():
    print("    0 1 2 3 4 5 6 7 8 9")
    print("--+--------------------")
    for i in range(10):
        S = " "+str(i)+"|"
        for j in range(10):
            S+=" "+ str(connect[i][j])
        print(S)
def Initialize():#初期化
    global NUMINPUT,NUMNODE,NumOfLearn
    SumQin[0] = 0
    for i in range(NUMINPUT):
        SumQin[i+1] = SumQin[i] + Qin[i]
        sumQ[0][i] = 0; sumQ[1][i] = Q[0][i]
        sumQ[2][i] = Q[0][i] + Q[1][i]
    for i in range(NUMNODE):
        for j in range(NUMNODE): W[i][j] = 0
    for i in range(200):
        sigmoidTable[i] = 1.0/(1.0+math.exp(-0.1*float(i-100)))
    NumOfLearn = 0
    for i in range(NUMNODE):
        for j in range(NUMNODE):
            W[i][j]=(random.random()-0.5)*2

    
def RefferSigmoidTable2(Net):
    S = 1.0/(1.0+ math.exp(-Net));R = random.random()
    if R < S : return 1
    return 0
def RefferSigmoidTable(Net):#テーブルSigmoid値の参照
    ID = int(Net * 10 + 100)
    if ID > 199 :ID = 199
    if ID < 0   :ID = 0
    R = random.random()
    if R < sigmoidTable[ID] :return 1
    return 0
def bitStr(ID):
    S = ""; k = ID
    for i  in range(1,4):
        KK = k % 2;S=str(KK)+S; k=int((k-KK)/2)
    return S
def dspLearnResult():#学習結果表示
    print("■ノードの値")
    for i in range(NUMNODE): print("%4d,%4d"%(i,X[i]))
    printArray(W,Title="■重み行列",frm="%8.4f")
    print("実行回数", NumOfLearn)
    print("InputPattern", str(InputPattern) +
          "(" + bitStr(InputPattern) + ")")
    print("誤差",ERR)
def setInputTrainningDT():#■入力パターン設定
    global NUMINPUT
    R = random.random(); InputPattern=NUMINPUT-1
    for i in range(NUMINPUT):
        if Qin[i]!=0 and R>=SumQin[i] and R<SumQin[i+1]:
            InputPattern=i;break
    tmp = InputPattern; X[0]=1
    for i in range(1,4):
        X[i]= tmp % 2; tmp=int((tmp- X[i])/2)
    return InputPattern
def initOutFreq(InputPattern):#■入力パターンに対する
    global NUMNODE            #　出力頻度初期化
    for i in range(NUMNODE):
        for j in range(i+1): Wp[i][j]=0; Wn[i][j]=0
    for i in range(2):
        numID[i][InputPattern] = 0
        P[i][InputPattern] = 0
def fixOutNeuron(N,InputPattern):#■出力固定
    R = random.random()
    for i in range(2):
        if (Q[i][InputPattern]!=0 and R>=sumQ[i][InputPattern]
            and R<sumQ[i+1][InputPattern]): break
    if i>1: i = 1
    OutputPattern = i; X[N] = OutputPattern % 2
    return OutputPattern
def mltNet(j):#■Wj*Xi
    global NUMNODE
    Net = 0
    for i in range(NUMNODE):Net += W[i][j]*X[i]
    return Net
def freqBoth1(Wpn):#■結線の両側の素子が同時に1になる頻度
    global NUMNODE
    for i in range(NUMNODE):
        for j in range(i):
            if connect[i][j]!=0: Wpn[i][j]+=X[i]*X[j]
    return Wpn
def learnUsedTrainingData():#訓練データセットによる学習()
    global ERR,NUMFREQ,NUMNODE,NUMINPUT,Wp,Wn
    global Eps,NumOfLearn,NumUpdate,MaxLearn
    InputPattern = setInputTrainningDT()
    initOutFreq(InputPattern)#出力頻度初期化
    #出力素子を Neuron 9 に固定
    OutputPattern = fixOutNeuron(9,InputPattern)
    for num in range(NumUpdate):#入出力素子値固定
        for j in range(4,NUMNODE-1):#隠れ素子値の更新
            X[j]= RefferSigmoidTable(mltNet(j))
        Wp=freqBoth1(Wp)#結線の両側の素子が同時に1になる頻度
    OldPattern = OutputPattern
    for num in range(NumUpdate):#入力値固定
        for j in range(4,NUMNODE):#隠れ+出力素子値の更新
            X[j] = RefferSigmoidTable(mltNet(j))
        Wn=freqBoth1(Wn)#結線の両側の素子が同時に1になる頻度
        OutputPattern = 0 #出現した出力素子値組
        for i in range(9,8,-1):
            OutputPattern=int(OutputPattern*2+X[i]+0.5)
        numID[OutputPattern][InputPattern]+=1
    for i in range(2):#頻度設定
        P[i][InputPattern]=numID[i][InputPattern]/NumUpdate
    for i in range(NUMNODE):#重み修正
        for j in range(i):
            if connect[i][j]!=0:
                W[i][j]+=Eps*(Wp[i][j]-Wn[i][j])/NumUpdate
                W[j][i] = W[i][j]
    if dspLearn : dspLearnResult()#途中経過表示
    if debugMode:#デバッグ時表示
        print("\n",NumOfLearn,"回目　Wp 出力",OldPattern,
              " 入力 ",InputPattern, "(",bitStr(InputPattern),")")
        printTriArray(Wp,Title="Wp",frm="%7.1f")
        printTriArray(Wn,Title="Wn",frm="%7.1f")
        printArray(W,Title="W")
    ERR=0;    #誤差評価
    ii=InputPattern
    for j in range(2):
        if Q[j][ii]!=0:
            V=Q[j][ii]/(P[j][ii]+0.00001)
            ERR+= Q[j][ii]*math.log(V)
def execBoltzmannMachine():#■実行確認
    for i in range(2):#頻度用領域＝0
        for j in range(8): numID[i][j] = 0; P[i][j] = 0
    for InputPattern in range(NUMINPUT):
        tmp = InputPattern  #入力パターンを0からデータ番号とする
        for i in range(1,4):#入力パターンを素子に振り分ける
            X[i] = tmp % 2; tmp = int((tmp-X[i])/ 2)
        for num in range(NumUpdate):#更新回数だけ繰り返す
            for j in range(4,NUMNODE):#隠れ素子と出力
                X[j] = RefferSigmoidTable(mltNet(j))
            OutputPattern = 0#出現パターン
            for i in range(NUMNODE-1, NUMNODE-2, -1):
                OutputPattern = OutputPattern * 2 + X[i]
            numID[OutputPattern][InputPattern]+= 1
    for i in range(2):#出現回数を頻度に変換
        for j in range(8):
            P[i][j] = numID[i][j] / NumUpdate
    print("\nInput   j      P0        P1")
    print("----------------------------")
    for j in range(8):
        print(" "+bitStr(j),("%4d, %8.4f, %8.4f"%(j,P[0][j],P[1][j])))
    ERR= 0#誤差の計算
    for i in range(NUMINPUT):
        E = 0
        for j in range(2):
            if Q[j][i]>1E-32:
                E+=(Q[j][i]*
                    math.log(Q[j][i]/(P[j][i]+0.000001)))
        ERR += Qin[i]*E
    print("\n実行誤差",ERR)
def batchLearn():#■一括学習
    Initialize()
    for NumOfLearn in range(MaxLearn):
        learnUsedTrainingData()
        print(NumOfLearn,",",ERR)
#■メイン・プログラム
printConnect()
batchLearn()
execBoltzmannMachine()

